#
# Module manifest for module 'xCertificate'
#
# Generated by: PowerShell DSC
#
# Generated on: 4/8/2015
#

@{

# Script module or binary module file associated with this manifest.
# RootModule = ''

# Version number of this module.
ModuleVersion = '2.2.0.0'

# ID used to uniquely identify this module
GUID = '1b8d785e-79ae-4d95-ae58-b2460aec1031'

# Author of this module
Author = 'Microsoft Corporation'

# Company or vendor of this module
CompanyName = 'Microsoft Corporation'

# Copyright statement for this module
Copyright = '(c) 2015 Microsoft Corporation. All rights reserved.'

# Description of the functionality provided by this module
Description = 'This module includes DSC resources that simplify administration of certificates on a Windows Server'

# Minimum version of the Windows PowerShell engine required by this module
PowerShellVersion = '4.0'

# Name of the Windows PowerShell host required by this module
# PowerShellHostName = ''

# Minimum version of the Windows PowerShell host required by this module
# PowerShellHostVersion = ''

# Minimum version of Microsoft .NET Framework required by this module
# DotNetFrameworkVersion = ''

# Minimum version of the common language runtime (CLR) required by this module
# CLRVersion = ''

# Processor architecture (None, X86, Amd64) required by this module
# ProcessorArchitecture = ''

# Modules that must be imported into the global environment prior to importing this module
# RequiredModules = @()

# Assemblies that must be loaded prior to importing this module
# RequiredAssemblies = @()

# Script files (.ps1) that are run in the caller's environment prior to importing this module.
# ScriptsToProcess = @()

# Type files (.ps1xml) to be loaded when importing this module
# TypesToProcess = @()

# Format files (.ps1xml) to be loaded when importing this module
# FormatsToProcess = @()

# Modules to import as nested modules of the module specified in RootModule/ModuleToProcess
# NestedModules = @()

# Functions to export from this module
FunctionsToExport = '*'

# Cmdlets to export from this module
CmdletsToExport = '*'

# Variables to export from this module
VariablesToExport = '*'

# Aliases to export from this module
AliasesToExport = '*'

# DSC resources to export from this module
# DscResourcesToExport = @()

# List of all modules packaged with this module
# ModuleList = @()

# List of all files packaged with this module
# FileList = @()

# Private data to pass to the module specified in RootModule/ModuleToProcess. This may also contain a PSData hashtable with additional module metadata used by PowerShell.
PrivateData = @{

    PSData = @{

        # Tags applied to this module. These help with module discovery in online galleries.
        Tags = @('DesiredStateConfiguration', 'DSC', 'DSCResourceKit', 'DSCResource')

        # A URL to the license for this module.
        LicenseUri = 'https://github.com/PowerShell/xCertificate/blob/master/LICENSE'

        # A URL to the main website for this project.
        ProjectUri = 'https://github.com/PowerShell/xCertificate'

        # A URL to an icon representing this module.
        # IconUri = ''

        # ReleaseNotes of this module
        ReleaseNotes = '* Converted appveyor.yml to install Pester from PSGallery instead of from Chocolatey.
* Moved unit tests to correct folder structure.
* Changed unit tests to use standard test templates.
* Updated all resources to meet HQRM standards and style guidelines.
* Added .gitignore file
* Added .gitattributes file to force line endings to CRLF to allow unit tests to work.
* xCertificateCommon:
    - Moved common code into new module CertificateCommon.psm1
    - Added standard exception code.
    - Renamed common functions Validate-* to use acceptable verb Test-*.
    - Added help to all functions.
* xCertificateImport:
    - Fixed bug with Test-TargetResource incorrectly detecting change required.
    - Reworked unit tests for improved code coverage to meet HQRM standards.
    - Created Integration tests for both importing and removing an imported certificate.
    - Added descriptions to MOF file.
    - Removed default parameter values for parameters that are required or keys.
    - Added verbose messages.
    - Split message and error strings into localization string files.
    - Added help to all functions.
* xPfxImport:
    - Fixed bug with Test-TargetResource incorrectly detecting change required.
    - Reworked unit tests for improved code coverage to meet HQRM standards.
    - Created Integration tests for both importing and removing an imported certificate.
    - Added descriptions to MOF file.
    - Removed default parameter values for parameters that are required or keys.
    - Added verbose messages.
    - Split message and error strings into localization string files.
    - Added help to all functions.
* xCertReq:
    - Cleaned up descriptions in MOF file.
    - Fixed bugs generating certificate when credentials are specified.
    - Allowed output of certificate request when credentials are specified.
    - Split message and error strings into localization string files.
    - Created unit tests and integration tests.
    - Improved logging output to enable easier debugging.
    - Added help to all functions.
* xPDT:
    - Renamed to match standard module name format (MSFT_x).
    - Modified to meet 100 characters or less line length where possible.
    - Split message and error strings into localization string files.
    - Removed unused functions.
    - Renamed functions to standard verb-noun form.
    - Added help to all functions.
    - Fixed bug in Wait-Win32ProcessEnd that prevented waiting for process to end.
    - Added Wait-Win32ProcessStop to wait for a process to stop.
    - Removed unused and broken scheduled task code.

'

    } # End of PSData hashtable

} # End of PrivateData hashtable

# HelpInfo URI of this module
# HelpInfoURI = ''

# Default prefix for commands exported from this module. Override the default prefix using Import-Module -Prefix.
# DefaultCommandPrefix = ''

}


